/*----------------------------------------------------------------------------*/
/* external.h - external global declarations from ep.h.
 */
/*----------------------------------------------------------------------------*/

#include <stdio.h>

/* file pointers */
FILE *outfp, *infp;

/* Global structures and variables */
struct individual
  {
    double *chrom;		/* chromosome string for the individual
				 */
    double fitness;		/* fitness of the individual
				 */
    int index;			/* index to store no. of wins
				 */
  };
struct bestever
  {
    double *chrom;		/* chromosome string for the best-ever individual
				 */
    double fitness;		/* fitness of the best-ever individual
				 */
    int generation;		/* generation which produced it
				 */
  };

extern struct individual *oldpop;	/* last generation of individuals
					 */
extern struct individual *temppop;	/*temp. pop between oldpop and newpop?
					 */
extern struct individual *newpop;	/* next generation of individuals
					 */
extern struct bestever bestfit;	/* fittest individual so far
				 */
extern double sumfitness;	/* summed fitness for entire population
				 */
extern double max;		/* maximum fitness of population
				 */
extern double avg;		/* average fitness of population
				 */
extern double min;		/* minumum fitness of population
				 */
extern double inirange;		/* initial range for initializing the chrom
				 */
extern double scalefactor;	/* scaling factor for the mutation
				 */
extern double offset;		/* offset factor for
				   mutation */
extern int lchrom;		/* length of chromosome per individual
				 */
extern int numfiles;		/* number of open files
				 */
extern int popsize;		/* population size
				 */
extern int gen;			/* current generation number
				 */
extern int maxgen;		/* maximum generation number
				 */
extern int run;			/* current run number
				 */
extern int maxruns;		/* maximum number of runs to make
				 */

/* The package's prototype definitions go here... */
#include "proto.h"

/* Application-dependent external declarations go after here... */
