/* operators.c - Operator: Mutation */

#include "external.h"
#include <math.h>

#define STDDEV	1.0E-6

/* Mutate all allele with gaussian noise with variance proportional
   to their fitness */
mutation ()
{
  int j, k;
  double step, tmp;

  for (j = 0; j < popsize; j++)
    {
      if ((tmp = offset + scalefactor * oldpop[j].fitness) < 0)
         step = STDDEV;
      else
        step = sqrt (tmp);
      for (k = 0; k < lchrom; k++)
	{
	  temppop[j + popsize].chrom[k] = oldpop[j].chrom[k] +
	    noise (0.0, step);
	}
      objfunc (&temppop[j + popsize]);
    }
}
